//#include <stdio.h>
//#include "mpi.h"
import mpi.*;
import java.lang.*;

//int main(argc, argv)
//int argc;
//char **argv;
class timers {
  static public void main(String[] args) {

    int    err = 0;
    double t1, t2, time;
    double tick;
    int    i;

    //MPI_Init( &argc, &argv );
    MPI.Init(args);
    t1 = MPI.Wtime();
    t2 = MPI.Wtime();
    if (t2 - t1 > 0.1 || t2 - t1 < 0.0) {
      err++;
      /* fprintf( stderr, 
      "Two successive calls to MPI_Wtime gave strange results: (%f) (%f)\n", 
       t1, t2 ); */
      System.out.println
	("Two successive calls to MPI.Wtime gave strange results:" +
	 " t1="+t1+","+" t2="+t2);
    }
/* Try several times to get a 1 second sleep */
    for (i = 0; i<10; i++) {
      t1 = MPI.Wtime();
      try { Thread.sleep(1000); } 
      catch(InterruptedException e) { } 
      t2 = MPI.Wtime();
      if (t2 - t1 >= 1.0 && t2 - t1 <= 5.0) break;
      if (t2 - t1 > 5.0) i = 9;
    }
    if (i == 10) {
      /* fprintf
	 ( stderr, "Timer around sleep(1) did not give 1 second; gave %f\n",
	 t2 - t1 );
	 fprintf
	 ( stderr, "If the sigchk check shows that SIGALRM is in use, \n\
	 this indicates only that user programs must NOT use any system call or\n\
	 library that uses SIGALRM.  SIGALRM is not used by MPICH but may be used\n\
	 by the software the MPICH uses to implement communication to other \n\
	 processes\n" ); */
      time = t2 - t1;
      System.out.println
	("Timer around sleep(1) did not give 1 second; gave "+
	 time);
      /* System.out.println
	("If the sigchk check shows that SIGALRM is in use, \n
          this indicates only that user programs must NOT
          use any system call or library that uses SIGALRM.
          SIGALRM is not used by MPICH but may be used by
          the software the MPICH uses to implement communication 
          to other processes" ); */
      err++;
    } 
    tick = MPI.Wtick();
    if (tick > 1.0 || tick < 0.0) {
      err++;
      /* fprintf
      ( stderr, "MPI_Wtick gave a strange result: (%f)\n", tick ); */
      System.out.println
	("MPI.Wtick gave a strange result:"+" tick="+tick);
    }
    //Test_Waitforall( );
    MPI.Finalize( );

    //return err;
  }

}
